{Polarwolf Library V2.2}

Function NrOfIcons : Byte;
  Begin
    NrOfIcons := IconField^ [1]
  End;

Procedure InitCrIC;
  Begin
    New (IconField);
    FillChar (IconField^, SizeOf (IconField^), #0);
    IconFieldSize := 1
  End;

Procedure CreateIcon (XPos, YPos : Word; XGr, YGr : Byte; Name : TIPName);
  Var IconGroesse : Word;
      I : Word;
  Begin
    For I := 1 To Length (Name) Do Name [I] := UpCaseGr (Name [I]);
    For I := IconFieldSize DownTo NrOfIcons*24 +2 Do
      IconField^ [I +24] := IconField^ [I];
    IconFieldSize := IconFieldSize + 24;
    IconField^ [NrOfIcons *24+ 2] := Hi (XPos);
    IconField^ [NrOfIcons *24+ 3] := Lo (XPos);
    IconField^ [NrOfIcons *24+ 4] := Hi (YPos);
    IconField^ [NrOfIcons *24+ 5] := Lo (YPOs);
    IconField^ [NrOfIcons *24+ 6] := XGr;
    IconField^ [NrOfIcons *24+ 7] := YGr;
    IconField^ [NrOfIcons *24+ 8] := Hi (IconFieldSize - 24* (NrOfIcons +1));
    IconField^ [NrOfIcons *24+ 9] := Lo (IconFieldSize - 24* (NrOfIcons +1));
    CrICLastXGr := XGr;
    CrICLastYGr := YGr;
    CrICLastPosHi := HI (IconFieldSize -24* (NrOfIcons +1));
    CrICLastPosLo := Lo (IconFieldSize -24* (NrOfIcons +1));
    For I := 0 To 15 Do IconField^ [NrOfIcons *24 +10 + I] := Ord (Name[I]);
    GetImage (XPos, YPos, XPos + XGr -1, YPos + YGr -1,
      IconField^ [IconFieldSize +1]);
    IconFieldSize := IconFieldSize +
      ImageSize (XPos, YPos, XPos + XGr -1, YPos + YGr -1);
    Inc (IconField^ [1]);
  End;

Procedure DuplicateIcon (XPos, YPos : Word; Name : TIPName);
  Var IconGroesse : Word;
      I : Word;
  Begin
    For I := 1 To Length (Name) Do Name [I] := UpCaseGr (Name [I]);
    For I := IconFieldSize DownTo NrOfIcons*24 +2 Do
      IconField^ [I +24] := IconField^ [I];
    IconFieldSize := IconFieldSize + 24;
    IconField^ [NrOfIcons *24+ 2] := Hi (XPos);
    IconField^ [NrOfIcons *24+ 3] := Lo (XPos);
    IconField^ [NrOfIcons *24+ 4] := Hi (YPos);
    IconField^ [NrOfIcons *24+ 5] := Lo (YPos);
    IconField^ [NrOfIcons *24+ 6] := CRICLastXGr;
    IconField^ [NrOfIcons *24+ 7] := CRICLastYGr;
    IconField^ [NrOfIcons *24+ 8] := CRICLastPosHi;
    IconField^ [NrOfIcons *24+ 9] := CRICLastPosLo;
    For I := 0 To 15 Do IconField^ [NrOfIcons *24 +10 + I] := Ord (Name[I]);
    Inc (IconField^ [1])
  End;

Procedure WriteIconField (FileName : String);
  Var FileVar : File;
      I : Word;
  Begin
    Assign (FileVar, FileName);
    ReWrite (FileVar, IconFieldSize +1);
    BlockWrite (FileVar, IconField^, 1);
    Close (FileVar);
    Dispose (IconField);
  End;
