{Polarwolf Library V2.2}

Function LoNib (B : Byte) : Byte;
  Begin
    LoNib := B And 15
  End;

Function HiNib (B : Byte) : Byte;
  Begin
    HiNib := B Shr 4
  End;

Function HexC (B : Byte) : Char;
  Begin
    B := LoNib (B);
    If B > 9 Then B := B + 7;
    HexC := Chr (B + 48)
  End;

Function HexB (B : Byte) : String2;
  Begin
    HexB := HexC (HiNib (B)) + HexC (LoNib (B))
  End;

Function HexW (W : Word) : String4;
  Begin
    HexW := HexB (Hi (W)) + HexB (Lo (W))
  End;

Function Bin (B : Byte) : String8;
  Var I : Byte;
      S : String8;
  Begin
    S := '';
    For I := 1 To 8 Do
      Begin
        If Odd (B) Then S := '1' + S Else S := '0' + S;
        B := B Shr 1
      End;
    Bin := S
  End;

Function BCD (B : Byte) : Byte;
  Begin
    ToolsError := False;
    If B < 100 Then BCD := (B Div 10) Shl 4 + (B Mod 10)
      Else ToolsError := True
  End;

Function Hex2Dez (H : String4) : Word;
  Var I : Byte;
      W : Word;
  Begin
    ToolsError := False;
    W := 0;
    For I := 1 To Length (H) Do
      Begin
        W := W * 16;
        If H[I] > '9' Then H[I] := Chr (Ord ( Upcase (H[I])) - 7);
        If Pos (H[I], '0123456789:;<=>?') > 0 Then
          W := W + Ord (H[I]) - 48
          Else ToolsError := True
      End;
    Hex2Dez := W
  End;

Function Bin2Dez (H : String8) : Byte;
  Var B, I : Byte;
  Begin
    ToolsError := False;
    B := 0;
    For I := 1 To Length (H) Do
      Begin
        B := B SHL 1;
        If Pos (H[I], '01') > 0 Then
          B := B + Ord (H[I]) - 48
          Else ToolsError := True
      End;
    Bin2Dez := B
  End;

Function BCD2Dez (B : Byte) : Byte;
  Begin
    BCD2Dez := 10 * HiNib (B) + LoNib (B)
  End;

Function Pointer2String (P : Pointer) : String11;
  Begin
    Pointer2String := '$'+ HexW (Seg (P^)) + ':$' + HexW (Ofs (P^))
  End;
