{Polarwolf Library V2.2}

Function UpCaseGr (Ch : Char) : Char;
  Begin
    Case Ch Of
        '' : UpCaseGR := '';
        '' : UpCaseGR := '';
        '' : UpCaseGr := ''
      Else UpCaseGR := UpCase (Ch)
      End
  End;

Procedure Inkey (Var A : ASCII);
  Begin
    A.Ch := ReadKey;
    A.Scan := A.Ch = Nul;
    If A.Scan Then A.Ch := ReadKey;
    KbdEsc := A.Ch = ESC;
    If CapsOnly And (Not A.Scan) Then
      A.Ch := UpCaseGr (A.CH)
  End;

Procedure GetKey (Var A : ASCII);
  Var FirstTime : Boolean;
  Begin
    FirstTime := True;
    Repeat
      If FirstTime Then FirstTime := False Else Write (#7);
      Inkey (A);
    Until KbdEsc Or
        ((A.Scan = False) And (Pos(A.Ch, GetAllowed) > 0)) Or
        ((A.Scan = True ) And (Pos(A.Ch, GetScanAllowed) > 0))
  End;

Procedure ClearKBD;
  Var Ch : Char;
  Begin
    While KeyPressed Do Ch := ReadKey
  End;

Procedure Wait;
  Var A : ASCII;
  Begin
    Inkey (A)
  End;

Function GetKeyboardState : Word;
  Var Reg : Registers;
  Begin
    If ComputerType Then Reg.AH := $12 Else Reg.AH := $02;
    Intr ($16, Reg);
    If Not ComputerType Then Reg.AX := Reg.AX And 255;
    GetKeyboardState := Reg.AX
  End;

Procedure SetNumLock (Modus : Boolean);
  Begin
    If Modus Then BIOSKeyboardState := BIOSKeyboardState Or 32
      Else BIOSKeyboardState := BIOSKeyboardState And (255-32);
    KeyPressed
  End;

Procedure SetCapsLock (Modus : Boolean);
  Begin
    If Modus Then BIOSKeyboardState := BIOSKeyboardState Or 64
      Else BIOSKeyboardState := BIOSKeyboardState And (255-64);
    KeyPressed
  End;

Procedure SetScrollLock (Modus : Boolean);
  Begin
    If Modus Then BIOSKeyboardState := BIOSKeyboardState Or 16
      Else BIOSKeyboardState := BIOSKeyboardState And (255-16);
    KeyPressed
  End;
