{Polarwolf Library V2.2}

Procedure ListBox (Data: PListBoxData; DataLen, ShowLen : Byte; Var Result : Byte);
  Var X, Y, P, Offset : Byte;
      A : ASCII;

  Procedure InvertLine;
    Var H : Byte;
    Begin
      If P < Offset Then Exit;
      If P >= Offset + ShowLen Then Exit;
      H := StdColor;
      StdColor := StdBackground;
      StdBackground := H;
      GotoXY (X, Y + P - Offset);
      PrintInput (Data^[P]^);
      HideCursor;
      H := StdColor;
      StdColor := StdBackground;
      StdBackground := H;
      SetStdColor
    End;

  Procedure DrawBox;
    Var I : Byte;
    Begin
      SetStdColor;
      For I := 1 To  ShowLen Do
        Begin
          GotoXY (X, Y + I -1);
          If (I + Offset -1) <= DataLen Then
            PrintInput (Data^[I + Offset -1]^)
           Else Write (Space : GlobalIP.ILen);
        End;
      InvertLine
    End;

  Begin
    X := WhereX;
    Y := WhereY;
    P := Result;
    If DataLen = ShowLen Then Offset := 1 Else Offset := P;
    DrawBox;
    Repeat
      GetAllowed := CR;
      GetScanAllowed := Up + Down;
      GetKey (A);
      If KBDEsc Then Exit;
      If A.Scan And (A.Ch = Up) Then
        If P > 1 Then
         Begin
           Dec (P);
           If P < Offset Then Offset := P;
           DrawBox
         End
         Else Play (Beep);
      If A.Scan And (A.Ch = Down) Then
        If P < DataLen Then
          Begin
            Inc (P);
            If P = Offset + ShowLen Then Inc (Offset);
            DrawBox
          End
          Else Play (Beep);
    Until (Not A.Scan) And (A.Ch = CR);
    DrawBox;
    Result := P
  End;

Procedure ParseSwitch (Switch : String; Var Cmd : Char; Var Param : String);
  Var I : Byte;
  Begin
    Cmd:= ' ';
    Param := '';
    If (Switch [1] <> '/') And (Switch [1] <> '-') Then Exit;
    If Length (Switch) = 2 Then
      Begin
        Cmd := UpcaseGr (Switch [2]);
        Exit
      End;
    If Length (Switch) < 4 Then Exit;
    If Switch [3] <> ':' Then Exit;
    Cmd := Switch [2];
    Param := Copy (Switch, 4, 255);
    For I := 1 To Length (Param) Do Param [I] := UpcaseGr (Param [I])
  End;
