{Polarwolf Library V2.2}

Function IOResultMSG (Nr : Word) : String;
  Var NrString : String8;
  Begin
    Str(Nr, NrString);
    Case Nr Of
          0 : IOResultMSG := 'Ok';
          2 : IOResultMSG := 'Datei nicht gefunden';
          3 : IOResultMSG := 'Pfad nicht gefunden';
          4 : IOResultMSG := 'Zu viele offene Dateien';
          5 : IOResultMSG := 'Dateizugriff verweigert';
          6 : IOResultMSG := 'Ungltiger Handle';
         12 : IOResultMSG := 'Ungltiger Dateimodus';
         15 : IOResultMSG := 'Laufwerksnummer unzulssig';
         16 : IOResultMSG := 'Aktuelles Verzeichnis kann nicht gelscht werden';
         17 : IOResultMSG := 'Kopieren beim Umbenennen nicht mglich';
        100 : IOResultMSG := 'Lesefehler';
        101 : IOResultMSG := 'Schreibfehler';
        102 : IOResultMSG := 'Keine Datei zugeordnet';
        103 : IOResultMSG := 'Datei ist nicht geffnet';
        104 : IOResultMSG := 'Datei nicht zum Lesen geffnet';
        105 : IOResultMSG := 'Datei nicht zum Schreiben geffnet';
        106 : IOResultMSG := 'Ungltiges numerisches Format';
        150 : IOResultMSG := 'Diskette ist schreibgeschtzt';
        151 : IOResultMSG := 'Unbekanntes Peripheriegert';
        152 : IOResultMSG := 'Laufwerk nicht bereit';
        153 : IOResultMSG := 'Unbekannte DOS-Funktion';
        154 : IOResultMSG := 'CRC Prfsummenfehler beim Lesen von Diskette/Festplatte';
        155 : IOResultMSG := 'Ungltiger Disc-Parameterblock';
        156 : IOResultMSG := 'Kopf-Positionierungsfehler';
        157 : IOResultMSG := 'Unbekanntes Sektorformat';
        158 : IOResultMSG := 'Sektor nicht gefunden';
        160 : IOResultMSG := 'Schreibfehler beim Zugriff auf Peripheriegert';
        161 : IOResultMSG := 'Lesefehler beim Zugriff auf Peripheriegert';
        162 : IOResultMSG := 'Nicht nher bestimmbarer Hardware-Fehler';
        200 : IOResultMSG := 'Division durch Null';
        201 : IOResultMSG := 'Array auerhalb des erlaubten Bereiches';
        202 : IOResultMSG := 'Stack-berlauf';
        203 : IOResultMSG := 'Heap-berlauf';
        204 : IOResultMSG := 'Ungltige Zeiger-Operation';
        205 : IOResultMSG := 'Fliekomma-berlauf';
        206 : IOResultMSG := 'Fliekomma-Unterlauf';
        207 : IOResultMSG := 'Fliekomma-Fehler';
        208 : IOResultMSG := 'Overlay-Manager nicht installiert';
        209 : IOResultMSG := 'I/O Fehler beim Lesen der Overlay-Datei';
        210 : IOResultMSG := 'Objekt nicht initialisiert';
        211 : IOResultMSG := 'Zu viele Verschachtelungsebenen'
      Else    IOResultMSG := 'I/O Fehler N' + NrString
      End
  End;

Function CheckSumError (CheckCode, Dummy : Byte) : Boolean;
  Type TFileCheck = Array [0..255] Of Byte;
  Var FileVar : File;
      FileCheck : TFileCheck;
      SizeRest : LongInt;
      Count : Byte;
      W, S : Word;
  Begin
    CheckSUMError := True;
    Count := 0;
    S := 0;
    Assign (FileVar, ParamStr (0));
    Reset (FileVar, 1);
    If IOResult > 0 Then Exit;
    SizeRest := FileSize (FileVar);
    While SizeRest > 0 Do
      Begin
        If Count = 0 Then
          If SizeRest >= 256 Then BlockRead (FileVar, FileCheck, 256)
            Else BlockRead (FileVar, FileCheck, SizeRest);
        If IOResult > 0 Then Exit;
        W := FileCheck [Count] + Count;
        W := W XOr CheckCode;
        S := Lo (S + W);
        Inc (Count);
        Dec (SizeRest)
      End;
    Close (FileVar);
    If IOResult > 0 Then Exit;
    CheckSumError := S > 0
  End;
