Program DEMO1;
{Demonstration der Bildschirm- und Tastatursteuerung}
{Polarwolf Library  (C) Barbara Tikart  Polarwolf Hard & Software, Erlenbach}

Uses Crt, PWLIB;

Procedure DemoColor;
  Begin
    WriteLn ('Dies ist ein Text in normaler Schreibfarbe.');
    SetStdLightColor;
    WriteLn ('Dies ist ein Text in heller Schrift.');
    SetStdInvColor;
    WriteLn ('Dies ist ein Text in inverser Schrift.');
    StdColor := Green;
    SetStdColor;
    WriteLn ('Natrlich knnen Sie auch eigene Farben definieren.');
    StdColor := LightGray;
    WriteLn;
  End;

Procedure DemoCursor;
  Begin
    SetStdColor;
    Write ('Jetzt ist der Cursor eingeschaltet: (Taste) -->');
    Wait;
    WriteLn;
    HideCursor;
    Write ('Jetzt ist der Cursor ausgeschaltet: (Taste) -->');
    Wait;
    WriteLn;
    ShowAlternateCursor;
    Write ('Und jetzt die alternative Cursorform : (Taste) -->');
    Wait;
    WriteLn;
  End;

Procedure DemoKey;
  Var A : ASCII;
  Begin
    GetAllowed := 'ABCDEF';
    GetScanAllowed := F1;
    CapsOnly := True;
    WriteLn;
    WriteLn ('Bitte geben Sie jetzt einen Text ein. Sie drfen nur die ');
    WriteLn ('Buchstaben A-F verwenden. Beenden Sie die Eingabe mit F1');
    Repeat
      GetKey (A);
      If KbdESC Then
        Begin
          WriteLn;
          WriteLn ('Sie haben mit ESCAPE abgebrochen.');
          Exit
        End;
      If Not A.Scan Then Write (A.Ch)
    Until A.Scan And (A.Ch = F1);
    WriteLn;
    WriteLn;
    WriteLn ('Eingabe beendet.');
  End;

Procedure DemoLock;
  Var I : Word;
      R : Real;
  Begin
    ShowCursor;
    WriteLn;
    WriteLn ('Schauen Sie mal auf Ihre Tastatur!');
    Repeat
      SetNumLock (True);
      Delay (300);
      SetNumLock (False);
      SetCapsLock (True);
      Delay (300);
      SetCapsLock (False);
      SetScrollLock (True);
      Delay (300);
      SetScrollLock (False);
    Until KeyPressed;
    ClearKBD;
  End;

Procedure DemoKeyboardState;
  Const BothShiftKey = LeftShiftKey + RightShiftKey;
  Begin
    WriteLn;
    WriteLn ('Bitte drcken Sie beide SHIFT-Tasten gleichzeitig, ');
    WriteLn ('um das DEMO zu beenden.');
    Repeat Until (GetKeyboardState And BothShiftKey) = BothShiftKey
  End;

Begin
  SetStdColor;
  ClrScr;
  DemoColor;
  DemoCursor;
  DemoKey;
  DemoLock;
  DemoKeyboardState
End.